///////////////////////////////////////////////////////////////////////////////
// StandardKinematicsTransformation.h
#pragma once

#include "StandardKinematicsTransformationInterfaces.h"
#include "Cnc/TcCncKinematicsInterfaces.h"

class CStandardKinematicsTransformation 
	: public ITComObject
	, public ITcADI
	, public ITcWatchSource
	, public ITcCncBase
	, public ITcCncTrafo
///<AutoGeneratedContent id="InheritanceList">
///</AutoGeneratedContent>
{
public:
	DECLARE_IUNKNOWN()
	DECLARE_IPERSIST(CID_StandardKinematicsTransformationCStandardKinematicsTransformation)
	DECLARE_ITCOMOBJECT_LOCKOP()
	DECLARE_ITCADI()
	DECLARE_ITCWATCHSOURCE()
	DECLARE_ITCCNCBASE()
	DECLARE_ITCCNCTRAFO()
	DECLARE_OBJPARAWATCH_MAP()
	DECLARE_OBJDATAAREA_MAP()

	CStandardKinematicsTransformation();
	virtual	~CStandardKinematicsTransformation();

	virtual HRESULT TCOMAPI Forward(PTcCncTrafoParameter p);			
	virtual HRESULT TCOMAPI Backward(PTcCncTrafoParameter p);		
	virtual HRESULT TCOMAPI TrafoSupported(PTcCncTrafoParameter p, bool fwd);
	virtual HRESULT TCOMAPI GetDimensions(PULONG pForwardInput, PULONG pForwardOutput);

///<AutoGeneratedContent id="InterfaceMembers">
///</AutoGeneratedContent>

protected:
	DECLARE_ITCOMOBJECT_SETSTATE();

	ITcCncRegisterObjectPtr    m_spCnc;	 

	const ULONG                m_forwardNbrIn;	
	const ULONG                m_forwardNbrOut;

///<AutoGeneratedContent id="Members">
	MC_TcCncRegisterObject m_CncObjectRef;
///</AutoGeneratedContent>
};
